package HT.fx;

import fi.jyu.mit.fxgui.Dialogs;
import fi.jyu.mit.fxgui.ModalController;
import fi.jyu.mit.fxgui.ModalControllerInterface;
import javafx.fxml.FXML;
import javafx.scene.Node;
import javafx.scene.control.Button;
import javafx.scene.control.CheckBox;
import javafx.scene.control.DatePicker;
import javafx.scene.control.TextField;
import javafx.stage.Stage;
import HT.fx.Pelaaja;
import HT.fx.Pelaajat;

import java.time.format.DateTimeFormatter;

import HT.fx.Karkelot;
import HT.fx.SailoException;

/**
 * @author joonatan, tuomas
 * @version 31.1.2024
 *
 */
public class LisaaPelaajaGUIController implements ModalControllerInterface<String> {
    @FXML private TextField textVastaus;
    


    @FXML private CheckBox boolonkoauto;

    @FXML private DatePicker datesyntaika;

    @FXML private TextField textnimi;

    @FXML private TextField textsahkoposti;
    
    @FXML private Button OKButton; 
    
    @FXML void handleOk() {
        
        
            kasitteleOk();
            Stage stage = (Stage) OKButton.getScene().getWindow();
            stage.close();

        
    }

    @FXML void handleAlusta() {
        alustamuokkaus();
    }
    
    @FXML void handlePoista() {
        if(muok>0) {
            Pelaaja pel = PadelMainGUIController.getKarkelo().annaPelaaja(muok);
            PadelMainGUIController.getKarkelo().poistaPelaaja(pel);
        
            Stage stage = (Stage) OKButton.getScene().getWindow();
            stage.close();
        }
        OtteluIkkunaGUIController.muokattava=-1;
    }
    

    //==========================================================
    
    
    /**
     * muokattavan pelaajan id
     */
    public int muok = PadelMainGUIController.muokattava;
    
    private void alustamuokkaus() {
       
        Pelaaja pel = PadelMainGUIController.getKarkelo().annaPelaaja(muok);
        textnimi.setText(pel.getNimi());
        datesyntaika.setValue(pel.getSyntaika());
        textsahkoposti.setText(pel.getSahkoposti());
        boolonkoauto.setSelected(pel.getAuto());

    }
    
    
    /**
     * Käsittelee Ok:n painamisen. Luo uuden pelaajan ja lisää sen controllerin karkeloon
     */
    public void kasitteleOk() {
        
        if(muok<0) {
        Pelaaja uusi = new Pelaaja(textnimi.getText(), datesyntaika.getValue() ,textsahkoposti.getText(),boolonkoauto.isSelected());
        //uusi.vastaaAkuAnkka();
        PadelMainGUIController.LisaaPelaaja(uusi); // lisää pelaajan karkeloon
        }
        
        if(muok>=0) {
            Pelaaja pel = PadelMainGUIController.getKarkelo().annaPelaaja(muok);
            pel.setNimi(textnimi.getText());
            pel.setSyntaika(datesyntaika.getValue());
            pel.setSahkoposti(textsahkoposti.getText());
            pel.setOnkoauto(boolonkoauto.isSelected());
        }
        
        PadelMainGUIController.muokattava = -1;
    }
    

    
    @Override
    public String getResult() {
        // TODO Auto-generated method stub
        return null;
    }

    @Override
    public void handleShown() {
        // TODO Auto-generated method stub
        
    }

    @Override
    public void setDefault(String arg0) {
        // TODO Auto-generated method stub
        
    }
    
}